"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _constants = require("constants");

/*
 *  ------------------------------------------------------------------------------------
 *  * Copyright (c) SAS Institute Inc.
 *  *  Licensed under the Apache License, Version 2.0 (the "License");
 *  * you may not use this file except in compliance with the License.
 *  * You may obtain a copy of the License at
 *  *
 *  * http://www.apache.org/licenses/LICENSE-2.0
 *  *
 *  *  Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS,
 *  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  * See the License for the specific language governing permissions and
 *  limitations under the License.
 * ----------------------------------------------------------------------------------------
 *
 */
'use strict';

var fs = require('fs');

var dns = require('dns');

var os = require('os');

function config(appEnv, cb) {
  console.log(appEnv);

  if (appEnv === null) {
    fixServer();
    cb(null, null);
  }

  iconfig(appEnv, cb);
}

function iconfig(appEnv, cb) {
  dns.lookup(os.hostname(), function (err, addr) {
    if (err) {
      console.log(err);
      cb(err);
    }

    console.log(process.env.APPHOSTADDR);
    var data = fs.readFileSync(appEnv, 'utf8');
    console.log(data);
    var d = data.split(/\r?\n/);
    console.log('Configuration specified via raf.env');
    d.forEach(function (l) {
      if (l.length > 0 && l.indexOf('#') === -1) {
        var la = l.split('=');
        var envName = la[0];

        if (la.length > 0) {
          if (la[1] === '') {
            delete process.env[envName];
          } else {
            process.env[envName] = la[1];
          } // console.log(`${envName}=${la[1]}`)

        }
      }
    });
    fixServer(addr);
    cb(null, 'Env file processed');
  });
}

function fixServer(addr) {
  process.env.SAS_PROTOCOL = process.env.SAS_SSL_ENABLED === 'YES' ? 'https://' : 'http://'; // fixing usual user error of adding a space after the url

  if (process.env.VIYA_SERVER != null) {
    var t = process.env.VIYA_SERVER.split(' ');
    process.env.VIYA_SERVER = t[0];

    if (process.env.VIYA_SERVER.indexOf('http') < 0) {
      process.env.VIYA_SERVER = process.env.SAS_PROTOCOL + process.env.VIYA_SERVER;
    }
  }

  if (process.env.APPHOST === '*') {
    process.env.APPHOST = os.hostname();
  } else if (process.env.APPHOST === '*ip') {
    process.env.APPHOST = addr;
  }
}

var _default = config;
exports.default = _default;