"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _constants = require("constants");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/*
 *  ------------------------------------------------------------------------------------
 *  * Copyright (c) SAS Institute Inc.
 *  *  Licensed under the Apache License, Version 2.0 (the "License");
 *  * you may not use this file except in compliance with the License.
 *  * You may obtain a copy of the License at
 *  *
 *  * http://www.apache.org/licenses/LICENSE-2.0
 *  *
 *  *  Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS,
 *  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  * See the License for the specific language governing permissions and
 *  limitations under the License.
 * ----------------------------------------------------------------------------------------
 *
 */
'use strict';

var fs = require('fs').promises;

var dns = require('dns').promises;

var os = require('os');

function config(appEnv) {
  console.log(appEnv);
  iconfig(appEnv).then(function () {
    return console.log('Processing of env completed');
  }).catch(function () {
    console.log('Failed to process env file');
  });
}

function iconfig(_x) {
  return _iconfig.apply(this, arguments);
}

function _iconfig() {
  _iconfig = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(appEnv) {
    var data, d;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return dns.lookup(os.hostname());

          case 3:
            process.env.APPHOSTADDR = _context.sent;
            console.log(process.env.APPHOSTADDR);

            if (!(appEnv !== null)) {
              _context.next = 16;
              break;
            }

            _context.next = 8;
            return fs.readFile(appEnv, 'utf8');

          case 8:
            data = _context.sent;
            console.log(data);
            d = data.split(/\r?\n/);
            console.log('Configuration specified via raf.env');
            d.forEach(function (l) {
              if (l.length > 0 && l.indexOf('#') === -1) {
                var la = l.split('=');
                var envName = la[0];

                if (la.length > 0) {
                  if (la[1] === '') {
                    delete process.env[envName];
                  } else {
                    process.env[envName] = la[1];
                  } // console.log(`${envName}=${la[1]}`)

                }
              }
            });
            fixServer();
            _context.next = 17;
            break;

          case 16:
            fixServer();

          case 17:
            _context.next = 23;
            break;

          case 19:
            _context.prev = 19;
            _context.t0 = _context["catch"](0);
            console.log(_context.t0);
            process.exit(0);

          case 23:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 19]]);
  }));
  return _iconfig.apply(this, arguments);
}

function fixServer() {
  process.env.SAS_PROTOCOL = process.env.SAS_SSL_ENABLED === 'YES' ? 'https://' : 'http://'; // fixing usual user error of adding a space after the url

  if (process.env.VIYA_SERVER != null) {
    var t = process.env.VIYA_SERVER.split(' ');
    process.env.VIYA_SERVER = t[0];

    if (process.env.VIYA_SERVER.indexOf('http') < 0) {
      process.env.VIYA_SERVER = process.env.SAS_PROTOCOL + process.env.VIYA_SERVER;
    }
  }
}

var _default = config;
exports.default = _default;